<?php
// $Id: ezmlm-author.php,v 1.1 2002/11/14 21:19:08 root Exp $
//
// ezmlm-author.php - ezmlm-php v2.0
// --------------------------------------------------------------
// Displays all messages by a given author
// --------------------------------------------------------------

require_once("ezmlm.php");

class ezmlm_author extends ezmlm_php {
	function display($authorhash) {
		$file = "/archive/authors/" . substr($authorhash,0,2) . "/" . substr($authorhash,2,18);
		if (!is_file($this->listdir . $file)) { $this->error(EZMLM_INVALID_AUTHOR); return; }

		$fd = @fopen($this->listdir . $file, "r");
		while (!feof($fd)) {
			$buf = fgets($fd,4096);
			if (preg_match('/^' . $authorhash . '/', $buf)) {
				// this should ALWAYS be the first line in the file
				$author = preg_replace('/^' . $authorhash . ' /', '', $buf);
				print "<span class=\"heading\">Messages from " . $author . "</span><br><br>\n";
				print "<table border=0 cellpadding=0 cellspacing=0>\n";
				$tableopened = TRUE;
			} else if (preg_match('/^[0-9]*:[0-9]/',$buf)) {
				// this is a valid message line
				// all we need is the first item
				$msgfile = preg_replace('/^([0-9]*):.*/', '\1', $buf);
				$msgdir  = (int)((int)$msgfile / 100);
				$msgfile = (int)$msgfile % 100;

				if ($msgfile < 10) { $msgfile = "0" . $msgfile; }

				if (!is_file($this->listdir . "/archive/" . $msgdir . "/" . $msgfile)) {
					print "<!-- " . $this->listdir . "/archive/" . $msgdir . "/" . $msgfile . " -->\n";
					$this->error(EZMLM_INCONSISTANCY);	
					fclose($fd);
					return;
				}

				$msg = new ezmlm_parser();
				$msg->parse_file($this->listdir . "/archive/" . $msgdir . "/" . $msgfile);
			
				$subject = $msg->headers['subject'];	
				$subject = preg_replace("/\[" . $this->listname . "\]/", "", $subject);
				print "<tr>\n";
                        	print "<td>" . $this->makelink("action=show_msg&actionargs[]=" . $msgdir . "&actionargs[]=" . $msgfile, $subject) . "</td>";
				print "<td>[" . $this->makelink("action=show_threads&actionargs[]=" . date("Ym", strtotime($msg->headers['date'])) . "#" . urlencode("/archive/" . $msgdir . "/" . $msgfile), "thread") . "]</td>\n";
				print "<td>" . date("M j Y, g:i a", strtotime($msg->headers['date'])) . "</td>\n";
				print "</tr>\n";
			}
		}
		if ($tableopened) { print "</table>\n"; }
	}
}
