<?php
// $Id: ezmlm-listinfo.php,v 1.2 2002/11/14 21:20:07 evan Exp $
//
// ezmlm-listinfo.php - ezmlm-php v2.0
// --------------------------------------------------------------
// Displays general list info in the format of a welcome page.
// --------------------------------------------------------------

require_once("ezmlm.php");

class ezmlm_listinfo extends ezmlm_php {
	function display() {
		$parser = new ezmlm_parser();

		print "<span class=\"heading\">List info for " . $this->listname . "@" . $this->listdomain;
		print "</span><br>\n";

		print "<a href=\"mailto: " . $this->listname . "-subscribe@" . $this->listdomain . "\">";
		print "Subscribe</a> ";

		print "<a href=\"mailto: " . $this->listname . "-help@" . $this->listdomain . "\">";
		print "Help</a> ";

		print "<a href=\"mailto: " . $this->listname . "-faq@" . $this->listdomain . "\">";
		print "FAQ</a> ";

		print "\n<br><hr noshade><br>\n";
		$this->show_info_file();
		print "<br><br>\n";

		print "<center>\n";
		$threads = new ezmlm_threads();
                $threads->listmessages();
		print "</center><br>\n";

		$this->show_recentmsgs();

	}

	function show_info_file() {
		if (is_file($this->listdir . "/text/info")) {
			$infofile = @file($this->listdir . "/text/info");
			while (list($line_num, $line) = each($infofile)) {
				print nl2br($line);
			}
		}
	}

	function show_recentmsgs($title = "Recent messages") {
		$parser = new ezmlm_parser();
		print "<span class=\"heading\">$title</span><br>\n";
                print "<table width=\"100%\" border=0 cellpadding=0 cellspacing=0>\n";
                print "<tr bgcolor=\"" . $this->tablecolours[0] . "\"><td><b>From</b></td><td><b>Subject</b></td><td><b>Date</b></td></tr>\n";
                print "<tr bgcolor=\"" . $this->tablecolours[1] . "\"><td colspan=3><hr></td></tr>\n";
                $ctc = 0;
                $recent = $parser->recent_msgs();
                while (list($key,$val) = each($recent)) {
                        print "<tr bgcolor=\"" . $this->tablecolours[$ctc] . "\">\n";
                        print "<td>";
			$hash = $this->makehash($val->headers['from']);
			print "<!-- $hash -->\n";
                        print $this->makelink("action=show_author_msgs&actionargs[]=" . $hash,$this->protect_email($val->headers['from'],TRUE));
                        print "</td>\n";
                        print "<td align=left valign=center>";
                        $actionargs = preg_split("/\//", $val->msgfile);
                        print $this->makelink("action=show_msg&actionargs[]=" . $actionargs[(count($actionargs) - 2)] . "&actionargs[]=" . $actionargs[(count($actionargs) - 1)],$val->headers['subject']);
                        print "</td>\n";

                        print "<td>" . $val->headers['date'] . "</td>\n";
                        print "</tr>\n";

                        $ctc++;
                        if ($ctc == count($this->tablecolours)) { $ctc = 0; }
                }
                print "</table>\n";
	}
}

