<?php
// $Id: ezmlm-msgdisplay.php,v 1.1 2002/11/14 21:20:15 evan Exp $
//
// ezmlm-msgdisplay.php - ezmlm-php v2.0
// --------------------------------------------------------------
// Will parse a template (if specified) and display a message.
// Includes a default template.
// --------------------------------------------------------------

require_once("ezmlm.php");

class ezmlm_msgdisplay extends ezmlm_php {
	// our template
	var $msgtmpl;

	// display: parses a message (using ezmlm_parser) and displays it
	// using a template
	function display($msgfile) {
		$msg = new ezmlm_parser();
		$msg->parse_file($msgfile);
		$relfile = preg_replace('!' . $this->listdir . '!', '', $msg->msgfile);
		$a1 = preg_replace('!/archive/(.*)/.*$!', '\1', $relfile);
		$a2 = preg_replace('!/archive/.*/(.*)$!', '\1', $relfile);
		$msgtime = strtotime($msg->headers['date']);
        	$threadidx = date("Ym", $msgtime);
		print "[" . $this->makelink("action=show_msg&actionargs[]=$a1&actionargs[]=" . ($a2 - 1), " previous ") . "] ";
		print "[" . $this->makelink("action=show_msg&actionargs[]=$a1&actionargs[]=" . ($a2 + 1), " next ") . "] ";
		print "[" . $this->makelink("action=show_threads&actionargs[]=" . $threadidx . "#" . urlencode($relfile), " threads ") . "] ";
		print "<br>\n";
		$this->parse_template($msg);
	}

	function parse_template($msg) {
		$startpos = strpos(strtolower($this->msgtmpl), '<ezmlm-headers>');
		$endpos = strpos(strtolower($this->msgtmpl), '</ezmlm-headers>');
		$headers = substr($this->msgtmpl,$startpos + 15,($endpos - $startpos - 15));

		for ($i = 0; $i < count($this->showheaders); $i++) {
			$val = $this->showheaders[$i];
			$headers_replace .= $headers;
			$hnpos = strpos(strtolower($headers_replace), '<ezmlm-header-name>');
			$headers_replace = substr_replace($headers_replace, ucfirst($val), $hnpos, 19);
			$hvpos = strpos(strtolower($headers_replace), '<ezmlm-header-value');
			$headers_replace = substr_replace($headers_replace, $this->protect_email($msg->headers[strtolower($val)]), $hvpos, 20);
		}
		$this->msgtmpl = substr_replace($this->msgtmpl, $headers_replace, $startpos, (($endpos + 16) - $startpos));

		if ($msg->multipart) {
			$part = NULL;
			for ($i = 0; $i < count($msg->parts); $i++) {
				if (preg_match('/' . $this->preferedtype . '/', $msg->parts[$i]->headers['content-type'][1])) {
					$part = $msg->parts[$i];
				}
			}
			if ($part == NULL) {
				// we couldn't find the prefered type, just use 0
				$part = $msg->parts[0];
			}
		} else {
			$part = $msg;
		}

		if (preg_match('/html/i', $part->headers['content-type'][1])) {
			$this->msgtmpl = preg_replace('/<ezmlm-body>/i', $this->cleanup_body($part->body,TRUE), $this->msgtmpl);
		} else {
			$this->msgtmpl = preg_replace('/<ezmlm-body>/i', '<pre>' . $this->cleanup_body($part->body,TRUE) . '</pre>', $this->msgtmpl);
		}

		print $this->msgtmpl;
	}	

	function ezmlm_msgdisplay() {
		$this->ezmlm_php();
		if (($this->msgtemplate != "") and (is_file($this->msgtemplate))) {
			$fd = fopen($this->msgtemplate, "r");
			while (!feof($fd)) { $this->msgtmpl .= fgets($fd,4096); }
			fclose($fd);
		} else {
			$this->msgtmpl = '
<table width="98%" bgcolor="#ffffff" border=1 cellpadding=4 cellspacing=0>
 <tr>
  <td>
   <table width="100%" bgcolor="#eeeeee" border=0 cellpadding=0 cellspacing=0>
    <ezmlm-headers>
    <tr>
     <td nowrap width="10%" align=right valign=top>&nbsp;<b><ezmlm-header-name> :</b>&nbsp;</td>
     <td align=left valign=top><ezmlm-header-value></td>
    </tr>
    <tr>
     <td width="10%"></td>
     <td bgcolor="#cccccc"></td>
    </tr>
    </ezmlm-headers>
   </table>
  </td>
 </tr>
 <tr>
  <td>
   <ezmlm-body>
  </td>
 </tr>
</table>
';
		}
	}
}
